<template>
  <st-content heading="Tutorías">
    <st-register v-model="dialog" @refreshData="refreshData" :key="componentKey"></st-register>
    <div class="content-body">
      <div class="table-heading">
        <st-search
          text="Buscar por nombre de tutoría"
          @enter="search($event)"
        />
        <st-primary-btn
          nombre="Registrar Tutoría"
          @click="open"
        />
      </div>
      <st-data-table
        :dataInfo = "{ headers,items,key }"
        :dataPath = "path"
        :loading = "loading"
      ></st-data-table>
    </div>
  </st-content>
</template>

<script>
  import Register from '@/components/tutorship/Register'
  import DataTable from '@/components/DataTable'
  import Select from '@/components/Select'
  import Search from '@/components/Search'

  export default {
  data () {
    return{
      key:'idTutoria',
      items: [],
      dialog: false,
      loading:false,
      componentKey: 0,
      path:{
        url: '/coordinador/tutorias/',
        id: 'idTutoria'
      },
      headers: [
        {
          text: 'Nombre de la tutoría',
          align: 'start',
          sortable: false,
          value: 'nombre',
        },
      ],
      filters:{
        search:'',
        estadoTut:'',
      }
    }
  },
  components: {
    'st-data-table' : DataTable,
    'st-select' : Select,
    'st-search': Search,
    'st-register': Register
  },
  methods: {
    async search(value){
      this.loading = true
      try{
        let { data: { data } } = await this.$api.getTutorships(this.$store.state.role.idUnit,value)
        this.items = data.filter((item) => {
          if (item.nombre !== 'Tutoría de Momento') return true
        })
      } catch (e) {
          this.$store.commit('setError', e)
      }
      this.loading = false
    },
    refreshData(response) {
      this.dialog=false;
      this.search('');
    },
    open() {
      this.dialog = true
      this.componentKey += 1; //forceRerender
    }
  },
  mounted(){
    this.search('')
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
